// Frame averager by Peter Popov
// Averages an ordered series of frames
// Useful for motion blur, radial blur (spin and zoom),
// twist blur etc.


#declare start_frame = 0;
#declare end_frame = 49;
#declare basename="c:\images\pov3win\signat"
#declare resolution=<640,480,0>; // z doesn't count
// this is the resolution of the input files
// only used to display memory usage

#declare channels=3; // image channels
// usually 3, 4 or more if you have alpha channels

#declare bits_per_channel=8;
#declare increment=1;  // use every n-th frame 
// 1 is all frames, 2 is every second frame etc.

#declare len = strlen ( str ( end_frame, 0, 0 ) );
#debug "\n\n"
#declare averaged_frames =
pigment
{
  average
  pigment_map
  {
    #declare i = start_frame;
    #declare j=0;
    #while (i <= end_frame)
      [j image_map { tga concat ( basename, str (i, -len, 0), ".tga" ) interpolate 2 } ]
      #debug concat ("Memory " + 
      str(j*resolution.x*resolution.y*channels*bits_per_channel/8/1024,0,0),
      "k\r")
      #declare j=j+1;
      #declare i=i+increment;
    #end
  }
}

plane { -z, 0 texture { pigment { averaged_frames } finish { ambient 5 diffuse 0 } } }

camera
{
  location <0.5,0.5,-1>
  up y
  right x
  look_at <0.5,0.5,0>
  orthographic
}

// Written by Peter Popov
// peter.popov@usa.net